#ifdef USE_ROUTINES
#define HL_PLUS_A
#define HL_MINUS_A
#define COMPARE_HL_DE
#define COMPARE_HL_BC
#define HL_MINUS_DE
#define HL_MINUS_BC
#define COMPLEMENT_BC
#define COMPLEMENT_DE
#define MINUS_BC
#define MINUS_DE
#define MINUS_HL
#define MULTIPLY_BC
#define MULTIPLY_DE
#endif

#ifdef HL_PLUS_A
Add_HL_A:
	add	a,l
	ld	l,a
	ret	nc
	inc	hl
	ret
#endif

#ifdef HL_MINUS_A
Sub_HL_A:
	push	bc
	ld	b,0
	ld	c,a
	or	a
	sbc	hl,bc
	pop	bc
	ret
#endif

#ifdef COMPARE_HL_DE
Cmp_HL_DE:
	or	a
	push	hl
	sbc	hl,de
	pop	hl
	ret
#endif

#ifdef COMPARE_HL_BC
Cmp_HL_BC:
	or	a
	push	hl
	sbc	hl,bc
	pop	hl
	ret
#endif

#ifdef HL_MINUS_DE
Sub_HL_DE:
	or	a
	sbc	hl,de
	ret
#endif

#ifdef HL_MINUS_BC
Sub_HL_BC:
	or	a
	sbc	hl,bc
	ret
#endif

#ifdef COMPLEMENT_BC
Cpl_BC:
	ld	a,b
	cpl
	ld	b,a
	ld	a,c
	cpl
	ld	c,a
	ret
#endif

#ifdef COMPLEMENT_DE
Cpl_DE:
	ld	a,d
	cpl
	ld	d,a
	ld	a,e
	cpl
	ld	e,a
	ret
#endif

#ifdef COMPLEMENT_HL
Cpl_HL:
	ld	a,h
	cpl
	ld	h,a
	ld	a,l
	cpl
	ld	l,a
	ret
#endif

#ifdef MINUS_BC
Neg_BC:
	ld	a,b
	cpl
	ld	b,a
	ld	a,c
	cpl
	ld	c,a
	inc	bc
	ret
#endif

#ifdef MINUS_DE
Neg_DE:
	ld	a,d
	cpl
	ld	d,a
	ld	a,e
	cpl
	ld	e,a
	inc	de
	ret
#endif

#ifdef MINUS_HL
Neg_HL:
	ld	a,h
	cpl
	ld	h,a
	ld	a,l
	cpl
	ld	l,a
	inc	hl
	ret
#endif

#ifdef MULTIPLY_BC
Mlt_BC:
	push	af
	ld	a,c
	dec	b
Mlt_BC_loop:
	add	a,c
	djnz	Mlt_BC_loop
	pop	af
	ret
#endif

#ifdef MULTIPLY_DE
Mlt_DE:
	push	af
	ld	a,e
	dec	d
Mlt_DE_loop:
	add	a,e
	dec	d
	jr	nz,Mlt_BC_loop
	pop	af
	ret
#endif